Index: uspace/lib/c/generic/io/console.c
===================================================================
--- uspace/lib/c/generic/io/console.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/generic/io/console.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,6 +1,6 @@
 /*
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2006 Josef Cejka
  * Copyright (c) 2006 Jakub Vana
- * Copyright (c) 2008 Jiri Svoboda
  * All rights reserved.
  *
@@ -35,4 +35,5 @@
  */
 
+#include <as.h>
 #include <libc.h>
 #include <async.h>
@@ -179,5 +180,11 @@
 }
 
-bool console_get_event(console_ctrl_t *ctrl, cons_event_t *event)
+/** Get console event.
+ *
+ * @param ctrl Console
+ * @param event Place to store event
+ * @return EOK on success, EIO on failure
+ */
+errno_t console_get_event(console_ctrl_t *ctrl, cons_event_t *event)
 {
 	if (ctrl->input_aid == 0) {
@@ -191,14 +198,10 @@
 		async_wait_for(aid, &rc);
 
-		if (rc != EOK) {
-			errno = rc;
-			return false;
-		}
+		if (rc != EOK)
+			return EIO;
 
 		rc = console_ev_decode(&result, event);
-		if (rc != EOK) {
-			errno = rc;
-			return false;
-		}
+		if (rc != EOK)
+			return EIO;
 	} else {
 		errno_t retval;
@@ -207,20 +210,26 @@
 		ctrl->input_aid = 0;
 
-		if (retval != EOK) {
-			errno = retval;
-			return false;
-		}
+		if (retval != EOK)
+			return EIO;
 
 		errno_t rc = console_ev_decode(&ctrl->input_call, event);
-		if (rc != EOK) {
-			errno = rc;
-			return false;
-		}
-	}
-
-	return true;
-}
-
-bool console_get_event_timeout(console_ctrl_t *ctrl, cons_event_t *event,
+		if (rc != EOK)
+			return EIO;
+	}
+
+	return EOK;
+}
+
+/** Get console event with timeout.
+ *
+ * @param ctrl Console
+ * @param event Place to store event
+ * @param timeout Pointer to timeout. This will be updated to reflect
+ *                the remaining time in case of timeout.
+ * @return EOK on success (event received), ETIMEOUT on time out,
+ *         EIO on I/O error (e.g. lost console connection), ENOMEM
+ *         if out of memory
+ */
+errno_t console_get_event_timeout(console_ctrl_t *ctrl, cons_event_t *event,
     usec_t *timeout)
 {
@@ -238,21 +247,18 @@
 	errno_t rc = async_wait_timeout(ctrl->input_aid, &retval, *timeout);
 	if (rc != EOK) {
+		if (rc == ENOMEM)
+			return ENOMEM;
 		*timeout = 0;
-		errno = rc;
-		return false;
+		return ETIMEOUT;
 	}
 
 	ctrl->input_aid = 0;
 
-	if (retval != EOK) {
-		errno = retval;
-		return false;
-	}
+	if (retval != EOK)
+		return EIO;
 
 	rc = console_ev_decode(&ctrl->input_call, event);
-	if (rc != EOK) {
-		errno = rc;
-		return false;
-	}
+	if (rc != EOK)
+		return EIO;
 
 	/* Update timeout */
@@ -261,5 +267,83 @@
 	*timeout -= NSEC2USEC(ts_sub_diff(&t1, &t0));
 
-	return true;
+	return EOK;
+}
+
+/** Create a shared buffer for fast rendering to the console.
+ *
+ * @param ctrl Console
+ * @param cols Number of columns
+ * @param rows Number of rows
+ * @param rbuf Place to store pointer to the shared buffer
+ * @return EOK on success or an error code
+ */
+errno_t console_map(console_ctrl_t *ctrl, sysarg_t cols, sysarg_t rows,
+    charfield_t **rbuf)
+{
+	async_exch_t *exch = NULL;
+	void *buf;
+	aid_t req;
+	ipc_call_t answer;
+	size_t asize;
+	errno_t rc;
+
+	exch = async_exchange_begin(ctrl->output_sess);
+	req = async_send_2(exch, CONSOLE_MAP, cols, rows, &answer);
+
+	asize = PAGES2SIZE(SIZE2PAGES(cols * rows * sizeof(charfield_t)));
+
+	rc = async_share_in_start_0_0(exch, asize, &buf);
+	if (rc != EOK) {
+		async_forget(req);
+		goto error;
+	}
+
+	async_exchange_end(exch);
+	exch = NULL;
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		goto error;
+
+	*rbuf = (charfield_t *)buf;
+	return EOK;
+error:
+	if (exch != NULL)
+		async_exchange_end(exch);
+	return rc;
+}
+
+/** Unmap console shared buffer.
+ *
+ * @param ctrl Console
+ * @param buf Buffer
+ */
+void console_unmap(console_ctrl_t *ctrl, charfield_t *buf)
+{
+	async_exch_t *exch = async_exchange_begin(ctrl->output_sess);
+	(void) async_req_0_0(exch, CONSOLE_UNMAP);
+	async_exchange_end(exch);
+
+	as_area_destroy(buf);
+}
+
+/** Update console rectangle from shared buffer.
+ *
+ * @param ctrl Console
+ * @param c0 Column coordinate of top-left corner (inclusive)
+ * @param r0 Row coordinate of top-left corner (inclusive)
+ * @param c1 Column coordinate of bottom-right corner (exclusive)
+ * @param r1 Row coordinate of bottom-right corner (exclusive)
+ *
+ * @return EOK on sucess or an error code
+ */
+errno_t console_update(console_ctrl_t *ctrl, sysarg_t c0, sysarg_t r0,
+    sysarg_t c1, sysarg_t r1)
+{
+	async_exch_t *exch = async_exchange_begin(ctrl->output_sess);
+	errno_t rc = async_req_4_0(exch, CONSOLE_UPDATE, c0, r0, c1, r1);
+	async_exchange_end(exch);
+
+	return rc;
 }
 
Index: uspace/lib/c/generic/time.c
===================================================================
--- uspace/lib/c/generic/time.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/generic/time.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -47,4 +47,5 @@
 #include <stdint.h>
 #include <stdio.h>
+#include <stdlib.h>
 #include <ctype.h>
 #include <assert.h>
Index: uspace/lib/c/include/adt/hash_table.h
===================================================================
--- uspace/lib/c/include/adt/hash_table.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/include/adt/hash_table.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -41,4 +41,5 @@
 #include <stdbool.h>
 #include <macros.h>
+#include <member.h>
 
 /** Opaque hash table link type. */
Index: uspace/lib/c/include/adt/list.h
===================================================================
--- uspace/lib/c/include/adt/list.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/include/adt/list.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -38,4 +38,5 @@
 
 #include <assert.h>
+#include <member.h>
 #include <stdbool.h>
 #include <stddef.h>
@@ -85,8 +86,8 @@
 
 #define list_get_instance(link, type, member) \
-	((type *) (((void *)(link)) - list_link_to_void(&(((type *) NULL)->member))))
+	member_to_inst(link, type, member)
 
 #define list_foreach(list, member, itype, iterator) \
-	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) 1) \
+	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) sizeof(itype)) \
 		for (link_t *_link = (list).head.next; \
 		    iterator = list_get_instance(_link, itype, member), \
@@ -94,5 +95,5 @@
 
 #define list_foreach_rev(list, member, itype, iterator) \
-	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) 1) \
+	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) sizeof(itype)) \
 		for (link_t *_link = (list).head.prev; \
 		    iterator = list_get_instance(_link, itype, member), \
@@ -154,5 +155,5 @@
 extern bool list_member(const link_t *, const list_t *);
 extern void list_splice(list_t *, link_t *);
-extern unsigned long list_count(const list_t *);
+extern size_t list_count(const list_t *);
 
 /** Returns true if the link is definitely part of a list. False if not sure. */
@@ -394,7 +395,7 @@
  *
  */
-static inline link_t *list_nth(const list_t *list, unsigned long n)
-{
-	unsigned long cnt = 0;
+static inline link_t *list_nth(const list_t *list, size_t n)
+{
+	size_t cnt = 0;
 
 	link_t *link = list_first(list);
Index: uspace/lib/c/include/capa.h
===================================================================
--- uspace/lib/c/include/capa.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/include/capa.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -37,10 +37,7 @@
 #define _LIBC_CAPA_H_
 
-#include <adt/list.h>
-#include <loc.h>
+#include <errno.h>
+#include <stddef.h>
 #include <stdint.h>
-#include <types/label.h>
-#include <types/vol.h>
-#include <vbd.h>
 
 /** Capacity unit */
Index: uspace/lib/c/include/clipboard.h
===================================================================
--- uspace/lib/c/include/clipboard.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/include/clipboard.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -36,4 +36,6 @@
 #define _LIBC_CLIPBOARD_H_
 
+#include <errno.h>
+
 extern errno_t clipboard_put_str(const char *);
 extern errno_t clipboard_get_str(char **);
Index: uspace/lib/c/include/io/con_srv.h
===================================================================
--- uspace/lib/c/include/io/con_srv.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/include/io/con_srv.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,4 +39,5 @@
 #include <async.h>
 #include <fibril_synch.h>
+#include <io/charfield.h>
 #include <io/color.h>
 #include <io/concaps.h>
@@ -83,4 +84,7 @@
 	void (*set_cursor_visibility)(con_srv_t *, bool);
 	errno_t (*get_event)(con_srv_t *, cons_event_t *);
+	errno_t (*map)(con_srv_t *, sysarg_t, sysarg_t, charfield_t **);
+	void (*unmap)(con_srv_t *);
+	void (*update)(con_srv_t *, sysarg_t, sysarg_t, sysarg_t, sysarg_t);
 };
 
Index: uspace/lib/c/include/io/console.h
===================================================================
--- uspace/lib/c/include/io/console.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/include/io/console.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2008 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,4 +37,5 @@
 
 #include <time.h>
+#include <io/charfield.h>
 #include <io/concaps.h>
 #include <io/kbd_event.h>
@@ -83,7 +84,12 @@
 extern void console_cursor_visibility(console_ctrl_t *, bool);
 extern errno_t console_get_color_cap(console_ctrl_t *, sysarg_t *);
-extern bool console_get_event(console_ctrl_t *, cons_event_t *);
-extern bool console_get_event_timeout(console_ctrl_t *, cons_event_t *,
+extern errno_t console_get_event(console_ctrl_t *, cons_event_t *);
+extern errno_t console_get_event_timeout(console_ctrl_t *, cons_event_t *,
     usec_t *);
+extern errno_t console_map(console_ctrl_t *, sysarg_t, sysarg_t,
+    charfield_t **);
+extern void console_unmap(console_ctrl_t *, charfield_t *);
+extern errno_t console_update(console_ctrl_t *, sysarg_t, sysarg_t, sysarg_t,
+    sysarg_t);
 
 #endif
Index: uspace/lib/c/include/ipc/console.h
===================================================================
--- uspace/lib/c/include/ipc/console.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/include/ipc/console.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2006 Josef Cejka
  * All rights reserved.
@@ -48,5 +49,8 @@
 	CONSOLE_SET_COLOR,
 	CONSOLE_SET_RGB_COLOR,
-	CONSOLE_SET_CURSOR_VISIBILITY
+	CONSOLE_SET_CURSOR_VISIBILITY,
+	CONSOLE_MAP,
+	CONSOLE_UNMAP,
+	CONSOLE_UPDATE
 } console_request_t;
 
Index: uspace/lib/c/include/macros.h
===================================================================
--- uspace/lib/c/include/macros.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/include/macros.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -55,8 +55,4 @@
 	    | ((((uint64_t) (up)) & 0xffffffff) << 32))
 
-#define member_to_inst(ptr_member, type, member_identif) \
-	((type *) (((void *) (ptr_member)) - \
-	    ((void *) &(((type *) 0)->member_identif))))
-
 #define _paddname(line)     PADD_ ## line ## __
 #define _padd(width, line, n)  uint ## width ## _t _paddname(line) [n]
Index: uspace/lib/c/include/member.h
===================================================================
--- uspace/lib/c/include/member.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/c/include/member.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2021 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBC_MEMBER_H_
+#define _LIBC_MEMBER_H_
+
+#include <stdint.h>
+
+#define member_to_inst(ptr_member, type, member_identif) \
+	((type *) (((uintptr_t) (ptr_member)) - \
+	    offsetof(type, member_identif)))
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/meson.build
===================================================================
--- uspace/lib/c/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -60,8 +60,6 @@
 src += files(
 	'generic/libc.c',
+	'generic/as.c',
 	'generic/ddi.c',
-	'generic/as.c',
-	'generic/bd.c',
-	'generic/bd_srv.c',
 	'generic/perm.c',
 	'generic/capa.c',
@@ -71,13 +69,9 @@
 	'generic/corecfg.c',
 	'generic/ctype.c',
-	'generic/devman.c',
+	'generic/device/clock_dev.c',
 	'generic/device/hw_res.c',
 	'generic/device/hw_res_parsed.c',
 	'generic/device/pio_window.c',
-	'generic/device/clock_dev.c',
-	'generic/device/led_dev.c',
 	'generic/dirent.c',
-	'generic/dhcp.c',
-	'generic/dnsr.c',
 	'generic/dlfcn.c',
 	'generic/elf/elf.c',
@@ -97,22 +91,11 @@
 	'generic/l18n/langs.c',
 	'generic/pcb.c',
+	'generic/pio_trace.c',
 	'generic/smc.c',
 	'generic/task.c',
 	'generic/imath.c',
-	'generic/inet/addr.c',
-	'generic/inet/endpoint.c',
-	'generic/inet/host.c',
-	'generic/inet/hostname.c',
-	'generic/inet/hostport.c',
-	'generic/inet/tcp.c',
-	'generic/inet/udp.c',
-	'generic/inet.c',
-	'generic/inetcfg.c',
-	'generic/inetping.c',
 	'generic/io/asprintf.c',
 	'generic/io/input.c',
 	'generic/io/io.c',
-	'generic/io/chardev.c',
-	'generic/io/chardev_srv.c',
 	'generic/io/chargrid.c',
 	'generic/io/output.c',
@@ -120,8 +103,6 @@
 	'generic/io/log.c',
 	'generic/io/logctl.c',
-	'generic/io/label.c',
 	'generic/io/kio.c',
 	'generic/io/klog.c',
-	'generic/io/serial.c',
 	'generic/io/snprintf.c',
 	'generic/io/vprintf.c',
@@ -131,7 +112,4 @@
 	'generic/io/console.c',
 	'generic/io/table.c',
-	'generic/iplink.c',
-	'generic/iplink_srv.c',
-	'generic/irc.c',
 	'generic/irq.c',
 	'generic/ieee_double.c',
@@ -181,11 +159,7 @@
 	'generic/assert.c',
 	'generic/bsearch.c',
-	'generic/pci.c',
-	'generic/pio_trace.c',
 	'generic/qsort.c',
 	'generic/ubsan.c',
 	'generic/uuid.c',
-	'generic/vbd.c',
-	'generic/vol.c',
 )
 
Index: uspace/lib/clui/tinput.c
===================================================================
--- uspace/lib/clui/tinput.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/clui/tinput.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -874,4 +874,6 @@
 errno_t tinput_read_i(tinput_t *ti, const char *istr, char **dstr)
 {
+	errno_t rc;
+
 	console_flush(ti->console);
 	if (console_get_size(ti->console, &ti->con_cols, &ti->con_rows) != EOK)
@@ -891,5 +893,6 @@
 
 		cons_event_t ev;
-		if (!console_get_event(ti->console, &ev))
+		rc = console_get_event(ti->console, &ev);
+		if (rc != EOK)
 			return EIO;
 
Index: uspace/lib/congfx/private/console.h
===================================================================
--- uspace/lib/congfx/private/console.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/congfx/private/console.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,4 +39,5 @@
 
 #include <gfx/context.h>
+#include <io/charfield.h>
 #include <io/console.h>
 #include <io/pixel.h>
@@ -54,8 +55,12 @@
 	/** Console bounding rectangle */
 	gfx_rect_t rect;
+	/** Clipping rectangle */
+	gfx_rect_t clip_rect;
 	/** File for printing characters */
 	FILE *fout;
 	/** Current drawing color */
 	pixel_t clr;
+	/** Shared console buffer */
+	charfield_t *buf;
 };
 
Index: uspace/lib/congfx/src/console.c
===================================================================
--- uspace/lib/congfx/src/console.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/congfx/src/console.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -48,6 +48,8 @@
 #include "../private/color.h"
 
+static errno_t console_gc_set_clip_rect(void *, gfx_rect_t *);
 static errno_t console_gc_set_color(void *, gfx_color_t *);
 static errno_t console_gc_fill_rect(void *, gfx_rect_t *);
+static errno_t console_gc_update(void *);
 static errno_t console_gc_bitmap_create(void *, gfx_bitmap_params_t *,
     gfx_bitmap_alloc_t *, void **);
@@ -55,14 +57,41 @@
 static errno_t console_gc_bitmap_render(void *, gfx_rect_t *, gfx_coord2_t *);
 static errno_t console_gc_bitmap_get_alloc(void *, gfx_bitmap_alloc_t *);
+static errno_t console_gc_cursor_get_pos(void *, gfx_coord2_t *);
+static errno_t console_gc_cursor_set_pos(void *, gfx_coord2_t *);
+static errno_t console_gc_cursor_set_visible(void *, bool);
 
 gfx_context_ops_t console_gc_ops = {
+	.set_clip_rect = console_gc_set_clip_rect,
 	.set_color = console_gc_set_color,
 	.fill_rect = console_gc_fill_rect,
+	.update = console_gc_update,
 	.bitmap_create = console_gc_bitmap_create,
 	.bitmap_destroy = console_gc_bitmap_destroy,
 	.bitmap_render = console_gc_bitmap_render,
-	.bitmap_get_alloc = console_gc_bitmap_get_alloc
+	.bitmap_get_alloc = console_gc_bitmap_get_alloc,
+	.cursor_get_pos = console_gc_cursor_get_pos,
+	.cursor_set_pos = console_gc_cursor_set_pos,
+	.cursor_set_visible = console_gc_cursor_set_visible
 };
 
+/** Set clipping rectangle on console GC.
+ *
+ * @param arg Console GC
+ * @param rect Rectangle
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t console_gc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	console_gc_t *cgc = (console_gc_t *) arg;
+
+	if (rect != NULL)
+		gfx_rect_clip(rect, &cgc->rect, &cgc->clip_rect);
+	else
+		cgc->clip_rect = cgc->rect;
+
+	return EOK;
+}
+
 /** Set color on console GC.
  *
@@ -92,23 +121,48 @@
 {
 	console_gc_t *cgc = (console_gc_t *) arg;
-	int rv;
 	gfx_coord_t x, y;
-
-	// XXX We should handle p0.x > p1.x and p0.y > p1.y
-
-	console_set_rgb_color(cgc->con, cgc->clr, cgc->clr);
-
-	for (y = rect->p0.y; y < rect->p1.y; y++) {
-		console_set_pos(cgc->con, rect->p0.x, y);
-
-		for (x = rect->p0.x; x < rect->p1.x; x++) {
-			rv = fputc('X', cgc->fout);
-			if (rv < 0)
-				return EIO;
+	gfx_coord_t cols;
+	gfx_rect_t crect;
+	charfield_t ch;
+
+	/* Make sure rectangle is clipped and sorted */
+	gfx_rect_clip(rect, &cgc->clip_rect, &crect);
+
+	cols = cgc->rect.p1.x - cgc->rect.p0.x;
+
+	ch.ch = cgc->clr >> 24;
+	ch.flags = CHAR_FLAG_DIRTY;
+	ch.attrs.type = CHAR_ATTR_RGB;
+	ch.attrs.val.rgb.fgcolor = cgc->clr ^ 0xffffff;
+	ch.attrs.val.rgb.bgcolor = cgc->clr;
+
+	for (y = crect.p0.y; y < crect.p1.y; y++) {
+		for (x = crect.p0.x; x < crect.p1.x; x++) {
+			cgc->buf[y * cols + x] = ch;
 		}
-
-		console_flush(cgc->con);
 	}
 
+	console_update(cgc->con, crect.p0.x, crect.p0.y,
+	    crect.p1.x, crect.p1.y);
+
+	return EOK;
+}
+
+/** Update console GC.
+ *
+ * @param arg Console GC
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t console_gc_update(void *arg)
+{
+	console_gc_t *cgc = (console_gc_t *) arg;
+
+	/*
+	 * XXX Before actually deferring update to here (and similarly other
+	 * GC implementations) need to make sure all consumers properly
+	 * call update.
+	 */
+	(void) cgc;
 	return EOK;
 }
@@ -131,4 +185,5 @@
 	sysarg_t rows;
 	sysarg_t cols;
+	charfield_t *buf = NULL;
 	errno_t rc;
 
@@ -140,4 +195,10 @@
 
 	rc = console_get_size(con, &cols, &rows);
+	if (rc != EOK)
+		goto error;
+
+	console_clear(con);
+
+	rc = console_map(con, cols, rows, &buf);
 	if (rc != EOK)
 		goto error;
@@ -153,9 +214,13 @@
 	cgc->rect.p0.y = 0;
 	cgc->rect.p1.x = cols;
-	cgc->rect.p1.y = rows - 1; /* make sure we avoid bottom-right corner */
+	cgc->rect.p1.y = rows;
+	cgc->clip_rect = cgc->rect;
+	cgc->buf = buf;
 
 	*rgc = cgc;
 	return EOK;
 error:
+	if (buf != NULL)
+		console_unmap(cgc->con, buf);
 	if (cgc != NULL)
 		free(cgc);
@@ -175,4 +240,7 @@
 	if (rc != EOK)
 		return rc;
+
+	console_clear(cgc->con);
+	console_unmap(cgc->con, cgc->buf);
 
 	free(cgc);
@@ -268,6 +336,6 @@
 	console_gc_bitmap_t *cbm = (console_gc_bitmap_t *)bm;
 	gfx_coord_t x, y;
-	int rv;
 	pixel_t clr;
+	charfield_t ch;
 	pixelmap_t pixelmap;
 	gfx_rect_t srect;
@@ -275,4 +343,5 @@
 	gfx_rect_t crect;
 	gfx_coord2_t offs;
+	gfx_coord_t cols;
 
 	if (srect0 != NULL)
@@ -289,5 +358,5 @@
 
 	gfx_rect_translate(&offs, &srect, &drect);
-	gfx_rect_clip(&drect, &cbm->cgc->rect, &crect);
+	gfx_rect_clip(&drect, &cbm->cgc->clip_rect, &crect);
 
 	pixelmap.width = cbm->rect.p1.x - cbm->rect.p0.x;
@@ -295,20 +364,21 @@
 	pixelmap.data = cbm->alloc.pixels;
 
+	cols = cbm->cgc->rect.p1.x - cbm->cgc->rect.p0.x;
+
 	if ((cbm->flags & bmpf_color_key) == 0) {
 		/* Simple copy */
 		for (y = crect.p0.y; y < crect.p1.y; y++) {
-			console_set_pos(cbm->cgc->con, crect.p0.x, y);
-
 			for (x = crect.p0.x; x < crect.p1.x; x++) {
 				clr = pixelmap_get_pixel(&pixelmap,
 				    x - offs.x - cbm->rect.p0.x,
 				    y - offs.y - cbm->rect.p0.y);
-				console_set_rgb_color(cbm->cgc->con, clr, clr);
-
-				rv = fputc('X', cbm->cgc->fout);
-				if (rv < 0)
-					return EIO;
-
-				console_flush(cbm->cgc->con);
+
+				ch.ch = clr >> 24;
+				ch.flags = CHAR_FLAG_DIRTY;
+				ch.attrs.type = CHAR_ATTR_RGB;
+				ch.attrs.val.rgb.fgcolor = clr ^ 0xffffff;
+				ch.attrs.val.rgb.bgcolor = clr;
+
+				cbm->cgc->buf[y * cols + x] = ch;
 			}
 		}
@@ -321,42 +391,38 @@
 				    x - offs.x - cbm->rect.p0.x,
 				    y - offs.y - cbm->rect.p0.y);
-				console_set_rgb_color(cbm->cgc->con, clr, clr);
-
-				if (clr != cbm->key_color) {
-					console_set_pos(cbm->cgc->con, x, y);
-					rv = fputc('X', cbm->cgc->fout);
-					if (rv < 0)
-						return EIO;
-
-					console_flush(cbm->cgc->con);
-				}
-
+
+				ch.ch = clr >> 24;
+				ch.flags = CHAR_FLAG_DIRTY;
+				ch.attrs.type = CHAR_ATTR_RGB;
+				ch.attrs.val.rgb.fgcolor = clr ^ 0xffffff;
+				ch.attrs.val.rgb.bgcolor = clr;
+
+				if (clr != cbm->key_color)
+					cbm->cgc->buf[y * cols + x] = ch;
 			}
 		}
 	} else {
 		/* Color key & colorize */
-		console_set_rgb_color(cbm->cgc->con, cbm->cgc->clr,
-		    cbm->cgc->clr);
+		ch.ch = 0;
+		ch.flags = CHAR_FLAG_DIRTY;
+		ch.attrs.type = CHAR_ATTR_RGB;
+		ch.attrs.val.rgb.fgcolor = cbm->cgc->clr;
+		ch.attrs.val.rgb.bgcolor = cbm->cgc->clr;
 
 		for (y = crect.p0.y; y < crect.p1.y; y++) {
 			for (x = crect.p0.x; x < crect.p1.x; x++) {
-
 				clr = pixelmap_get_pixel(&pixelmap,
 				    x - offs.x - cbm->rect.p0.x,
 				    y - offs.y - cbm->rect.p0.y);
 
-				if (clr != cbm->key_color) {
-					console_set_pos(cbm->cgc->con, x, y);
-					rv = fputc('X', cbm->cgc->fout);
-					if (rv < 0)
-						return EIO;
-
-					console_flush(cbm->cgc->con);
-				}
-
+				if (clr != cbm->key_color)
+					cbm->cgc->buf[y * cols + x] = ch;
 			}
 		}
 	}
 
+	console_update(cbm->cgc->con, crect.p0.x, crect.p0.y, crect.p1.x,
+	    crect.p1.y);
+
 	return EOK;
 }
@@ -375,4 +441,57 @@
 }
 
+/** Get cursor position on console GC.
+ *
+ * @param arg Console GC
+ * @param pos Place to store position
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t console_gc_cursor_get_pos(void *arg, gfx_coord2_t *pos)
+{
+	console_gc_t *cgc = (console_gc_t *) arg;
+	sysarg_t col;
+	sysarg_t row;
+	errno_t rc;
+
+	rc = console_get_pos(cgc->con, &col, &row);
+	if (rc != EOK)
+		return rc;
+
+	pos->x = col;
+	pos->y = row;
+	return EOK;
+}
+
+/** Set cursor position on console GC.
+ *
+ * @param arg Console GC
+ * @param pos New cursor position
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t console_gc_cursor_set_pos(void *arg, gfx_coord2_t *pos)
+{
+	console_gc_t *cgc = (console_gc_t *) arg;
+
+	console_set_pos(cgc->con, pos->x, pos->y);
+	return EOK;
+}
+
+/** Set cursor visibility on console GC.
+ *
+ * @param arg Console GC
+ * @param visible @c true iff cursor should be made visible
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t console_gc_cursor_set_visible(void *arg, bool visible)
+{
+	console_gc_t *cgc = (console_gc_t *) arg;
+
+	console_cursor_visibility(cgc->con, visible);
+	return EOK;
+}
+
 /** @}
  */
Index: uspace/lib/ddev/include/ipc/ddev.h
===================================================================
--- uspace/lib/ddev/include/ipc/ddev.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ddev/include/ipc/ddev.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -33,6 +33,6 @@
  */
 
-#ifndef _LIBC_IPC_DDEV_H_
-#define _LIBC_IPC_DDEV_H_
+#ifndef LIBDDEV_IPC_DDEV_H
+#define LIBDDEV_IPC_DDEV_H
 
 #include <ipc/common.h>
Index: uspace/lib/device/include/bd.h
===================================================================
--- uspace/lib/device/include/bd.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/device/include/bd.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2012 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdevice
+ * @{
+ */
+/** @file Block device client interface
+ */
+
+#ifndef LIBDEVICE_BD_H
+#define LIBDEVICE_BD_H
+
+#include <async.h>
+#include <offset.h>
+
+typedef struct {
+	async_sess_t *sess;
+} bd_t;
+
+extern errno_t bd_open(async_sess_t *, bd_t **);
+extern void bd_close(bd_t *);
+extern errno_t bd_read_blocks(bd_t *, aoff64_t, size_t, void *, size_t);
+extern errno_t bd_read_toc(bd_t *, uint8_t, void *, size_t);
+extern errno_t bd_write_blocks(bd_t *, aoff64_t, size_t, const void *, size_t);
+extern errno_t bd_sync_cache(bd_t *, aoff64_t, size_t);
+extern errno_t bd_get_block_size(bd_t *, size_t *);
+extern errno_t bd_get_num_blocks(bd_t *, aoff64_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/device/include/bd_srv.h
===================================================================
--- uspace/lib/device/include/bd_srv.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/device/include/bd_srv.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2012 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdevice
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBDEVICE_BD_SRV_H
+#define LIBDEVICE_BD_SRV_H
+
+#include <adt/list.h>
+#include <async.h>
+#include <fibril_synch.h>
+#include <stdbool.h>
+#include <offset.h>
+
+typedef struct bd_ops bd_ops_t;
+
+/** Service setup (per sevice) */
+typedef struct {
+	bd_ops_t *ops;
+	void *sarg;
+} bd_srvs_t;
+
+/** Server structure (per client session) */
+typedef struct {
+	bd_srvs_t *srvs;
+	async_sess_t *client_sess;
+	void *carg;
+} bd_srv_t;
+
+struct bd_ops {
+	errno_t (*open)(bd_srvs_t *, bd_srv_t *);
+	errno_t (*close)(bd_srv_t *);
+	errno_t (*read_blocks)(bd_srv_t *, aoff64_t, size_t, void *, size_t);
+	errno_t (*read_toc)(bd_srv_t *, uint8_t, void *, size_t);
+	errno_t (*sync_cache)(bd_srv_t *, aoff64_t, size_t);
+	errno_t (*write_blocks)(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
+	errno_t (*get_block_size)(bd_srv_t *, size_t *);
+	errno_t (*get_num_blocks)(bd_srv_t *, aoff64_t *);
+};
+
+extern void bd_srvs_init(bd_srvs_t *);
+
+extern errno_t bd_conn(ipc_call_t *, bd_srvs_t *);
+
+#endif
+
+/** @}
+ */
